function f = my_fun2(z)
f=sin(z)./(1+abs(z)).^2-cos(z).*log(1+abs(z).^4);
endfunction


function E = montecarlo(f,N)
x=rand(N,1);   
E = mean(f(x));
endfunction


// Algorithme sumerien-babylonien pour approx racine carree
function x = sumbab(a)
x=1 // condition initiale
maxit=500; //nombre maximum des iterations
for i=1:maxit
    //disp(i)
    x = (x+a/x)/2
    if abs(x^2-a) < 1.E-14
        break; //on est arrive a convergence! 
    end 
end
endfunction


// Algorithme sumerien-babylonien pour approx racine carree v2
function x = sumbab2(a)
x=1
i=0
maxit=10
while i<maxit
    //disp(i)
    if abs(x^2-a) > 1.E-14
        x = (x+a/x)/2;
        i=i+1 // iterations number        
    else 
        break; //on est arrive a convergence! 
    end    
end
endfunction

function resultat = racine(a,b,c)
d = b^2-4*a*c;
if a==0
    resultat = 'degenerated'
elseif d>0 then
    x1 = (-b-sqrt(d))/(2*a);
    x2 = (-b+sqrt(d))/(2*a);
    resultat = [x1; x2];
elseif d==0 then
    x1 = -b/(2*a);
    resultat = [x1; x1];
else
    x1=(-b-%i*sqrt(-d))/(2*a);
    x2=(-b+%i*sqrt(-d))/(2*a);
    resultat = [x1; x2];
end
endfunction


function phi=phi_syracuse(n)
    
if modulo(n,2)==0 then
    phi=n/2;
else
    phi=3*n+1;
end
endfunction

function u=syracuse(a,n)
u=a;
for i=1:n
    u=phi_syracuse(u);
    disp([i+1,u])    
end           
endfunction
