//TP1: quelques commentaires
//avant de execute cet fichier, il faut executer fonctionsTP1.sce

//Une variable est un objet informatique qui associe un nom à une valeur et peut varier au cours
//du temps. Elle se se caractérise par: son nom, son type, sa valeur, qui peut varier au fur et à mesure des instructions
//Une variable doit être déclarée: une fois et une seule, avant toute utilisation

alpha = 1.54; //regardez "Variable browser (ou "navigateur de variables" si vous avez la version en francais))"
b = 1.32;

//Pour chaque type de variable, on peut définir un certain nombre d'opérations. Par exemple, pour les variables numériques, 
//Scilab fournit toutes les opérations algébriques élémentaires. 
c =alpha**b + b; // equivalent a a^b + b
A=[3,4,14;2,3,4];// definition d'un tableau2*3

disp(A,'A = ')
A(2,3)=3;
disp(A,'A = ')
A = [1 2 3] , B = [2,3,4]
C = [1;3;5] , D = [1:4]
E = [1:10] , F = [1:2:10]
G = [1:3:10] , H = [1:4:10]
I = [1:4] , J = [1,2,3;4,5,6;7,8,9]
K = [3 4 ; alpha b]
G = K', H=C'
printf('size(C) =%d by %d\n',size(C,1),size(C,2))
printf('D(4) = %f\n',D(4))


//Affichage graphique
X= 0:0.01:1;
Xt=X';//transpose
//plot2d(Xt,[exp(Xt),exp(2*Xt)],[1,2],leg="exp(x)@exp(2x)", rect=[0,-2,2*%pi,2])
figure;
plot(Xt,exp(Xt),'g+')
plot(Xt,exp(2*Xt),'k*')
legend ('exp(x)','exp(2x)'); 
//clf()


//
// X and Y initialisation
// NB: here, X has the same lines and Y the same columns
A_1 = linspace(-1,1,50);
A_2 =  linspace(-1,3,50);
[X,Y] = meshgrid(A_1,A_2)
Z = cos(X.^2 + Y.^2); //X.^2 effectue l'élévation à la puissance élément par élément.

// example 1
figure;
surf(X,Y,Z,'facecol','red','edgecol','blu')


// Fonctions: Une fonction est un bloc d’instructions nommé et paramétré, réalisant une
//certaine tâche. Elle admet zéro, un ou plusieurs paramètres et renvoie toujours un résultat.

//declaration en ligne
deff('f=myfun(z)','f=sin(z)./(1+abs(z)).^2-cos(z).*log(1+abs(z).^4)');
format(7)
X=rand(3,3,2)+ %i*rand(3,3,2); //X est un tenseur 3x3x2 de nombres complexes
myfun(X)


//declaration dans une fichier (plus claire!!!)
//my_fun2 est definie dans fonctionsTP1.sci
e = my_fun2(X)-myfun(X);
norm(e(:))

//une variable peut etre une fonction!
f = my_fun2;
//f = my_fun;//ca ne marche pas (vous devez utiliser l'autre moyen pour déclarer les fonctions)
N = 1e5;
E = montecarlo(f,N);
Eex = intg(0,1,f); //integration numerique (on vais voir ca plus tard...)
printf('Montecarlo estimate: E=%f, true estimate Eex=%f\n',E,Eex)



